Index: main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormEntriesWorkflowMenu.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormEntriesWorkflowMenu.java	(revision 0)
+++ main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormEntriesWorkflowMenu.java	(revision 0)
@@ -0,0 +1,445 @@
+/*
+ *  Copyright 2016 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.plugins.forms.workflow;
+
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.LinkedHashSet;
+import java.util.List;
+import java.util.Map;
+import java.util.Set;
+
+import org.apache.avalon.framework.configuration.Configuration;
+import org.apache.avalon.framework.configuration.ConfigurationException;
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+
+import org.ametys.cms.repository.Content;
+import org.ametys.cms.workflow.AbstractContentWorkflowComponent;
+import org.ametys.plugins.forms.Form;
+import org.ametys.plugins.forms.FormsException;
+import org.ametys.plugins.forms.data.FieldValue;
+import org.ametys.plugins.forms.data.UserEntry;
+import org.ametys.plugins.forms.jcr.FormPropertiesManager;
+import org.ametys.plugins.forms.table.FormTableManager;
+import org.ametys.runtime.ui.impl.StaticContextualClientSideElement;
+import org.ametys.runtime.util.I18nizableText;
+
+import com.opensymphony.workflow.spi.Step;
+
+/**
+ * This element creates a toggle button representing a workflow state.
+ * A menu represents the available workflow actions. 
+ */
+public class FormEntriesWorkflowMenu extends StaticContextualClientSideElement
+{
+    /** Name of the workflow */
+    private String _workflowName;
+    /** Step id */
+    private int _workflowStepId;
+    /** Step name */
+    private String _workflowStepName;
+    /** Actions */
+    private int[] _workflowActionsIds;
+    /** Actions */
+    private Set<Integer> _commentActionsIds;
+    /** Actions */
+    private Set<Integer> _furtherInformationActionsIds;
+    /** Workflow component for form entries */
+    private FormEntriesWorkflow _formEntriesWorkflow;
+    
+    /** The manager of form SQL tables */
+    private FormTableManager _formTableManager;
+    
+    /** The manager of forms informations stored in JCR */
+    private FormPropertiesManager _formPropertiesManager;
+    
+    @Override
+    public void configure(Configuration configuration) throws ConfigurationException
+    {
+        super.configure(configuration);
+        
+        _configureWorkflowItems(configuration);
+        
+        _basicScriptParameters();
+        _advancedScriptParameters();
+        _workflowActionScriptParameters();
+    }
+    
+    @Override
+    public void service(ServiceManager serviceManager) throws ServiceException
+    {
+        _formEntriesWorkflow = (FormEntriesWorkflow) serviceManager.lookup(FormEntriesWorkflow.ROLE);
+        _formPropertiesManager = (FormPropertiesManager) serviceManager.lookup(FormPropertiesManager.ROLE);
+        _formTableManager = new FormTableManager();
+    }
+    
+    
+    private void _configureWorkflowItems(Configuration configuration) throws ConfigurationException
+    {
+        _workflowName = configuration.getChild("workflow").getAttribute("name");
+        _workflowStepId = configuration.getChild("workflow").getChild("step").getValueAsInteger();
+        _workflowStepName = _formEntriesWorkflow.getStepName(_workflowName, _workflowStepId);
+        
+        int[] allActionsId = _formEntriesWorkflow.getAllActionsFromStep(_workflowName, _workflowStepId);
+        
+        // Actions
+        Configuration actionsConfiguration = configuration.getChild("workflow").getChild("actions", false);
+        if (actionsConfiguration == null)
+        {
+            _workflowActionsIds = allActionsId;
+        }
+        else
+        {
+            boolean includeMode = "include".equals(actionsConfiguration.getAttribute("mode", "include"));
+            
+            Set<Integer> listedActions = new LinkedHashSet<Integer>();
+            for (Configuration actionConfiguration : actionsConfiguration.getChildren("action"))
+            {
+                int actionId = actionConfiguration.getValueAsInteger();
+                listedActions.add(actionId);
+            }
+            
+            // The set of available actions for this step
+            Set<Integer> availableActions = new LinkedHashSet<Integer>();
+
+            for (int i = 0; i < allActionsId.length; i++)
+            {
+                int actionId = allActionsId[i];
+                
+                boolean inList = listedActions.contains(actionId);
+                if (includeMode == inList)
+                {
+                    availableActions.add(actionId);
+                }
+            }
+
+            // Converting to int array
+            Integer[] actionsId = availableActions.toArray(new Integer[availableActions.size()]);
+            _workflowActionsIds = new int[actionsId.length];
+            for (int i = 0; i < actionsId.length; i++)
+            {
+                _workflowActionsIds[i] = actionsId[i];
+            }
+        }
+        
+        // Comments
+        Configuration commentsConfiguration = configuration.getChild("workflow").getChild("comments", false);
+        if (commentsConfiguration == null)
+        {
+            _commentActionsIds = new HashSet<Integer>();
+            for (int i = 0; i < allActionsId.length; i++)
+            {
+                _commentActionsIds.add(allActionsId[i]);
+            }
+        }
+        else
+        {
+            boolean includeMode = "include".equals(commentsConfiguration.getAttribute("mode", "include"));
+            
+            Set<Integer> listedActions = new LinkedHashSet<Integer>();
+            for (Configuration actionConfiguration : commentsConfiguration.getChildren("action"))
+            {
+                int actionId = actionConfiguration.getValueAsInteger();
+                listedActions.add(actionId);
+            }
+            
+            // The set of available actions for this step
+            Set<Integer> availableActions = new LinkedHashSet<Integer>();
+            
+            for (int i = 0; i < allActionsId.length; i++)
+            {
+                int actionId = allActionsId[i];
+                
+                boolean inList = listedActions.contains(actionId);
+                if (includeMode == inList)
+                {
+                    availableActions.add(actionId);
+                }
+            }
+            
+            // Converting to int array
+            Integer[] actionsId = availableActions.toArray(new Integer[availableActions.size()]);
+            _commentActionsIds = new HashSet<Integer>();
+            for (int i = 0; i < actionsId.length; i++)
+            {
+                _commentActionsIds.add(actionsId[i]);
+            }
+        }
+        
+        // Further information
+        Configuration furtherInfoConfiguration = configuration.getChild("workflow").getChild("further-information", false);
+        if (furtherInfoConfiguration == null)
+        {
+            _furtherInformationActionsIds = new HashSet<Integer>();
+            for (int i = 0; i < allActionsId.length; i++)
+            {
+                _furtherInformationActionsIds.add(allActionsId[i]);
+            }
+        }
+        else
+        {
+            boolean includeMode = "include".equals(furtherInfoConfiguration.getAttribute("mode", "include"));
+            
+            Set<Integer> listedActions = new LinkedHashSet<Integer>();
+            for (Configuration actionConfiguration : furtherInfoConfiguration.getChildren("action"))
+            {
+                int actionId = actionConfiguration.getValueAsInteger();
+                listedActions.add(actionId);
+            }
+            
+            // The set of available actions for this step
+            Set<Integer> availableActions = new LinkedHashSet<Integer>();
+            
+            for (int i = 0; i < allActionsId.length; i++)
+            {
+                int actionId = allActionsId[i];
+                
+                boolean inList = listedActions.contains(actionId);
+                if (includeMode == inList)
+                {
+                    availableActions.add(actionId);
+                }
+            }
+            
+            // Converting to int array
+            Integer[] actionsId = availableActions.toArray(new Integer[availableActions.size()]);
+            _furtherInformationActionsIds = new HashSet<Integer>();
+            for (int i = 0; i < actionsId.length; i++)
+            {
+                _furtherInformationActionsIds.add(actionsId[i]);
+            }
+        }
+    }
+    
+    private void _basicScriptParameters()
+    {
+        // Action
+        if (this._initialParameters.get("action") == null)
+        {
+            this._initialParameters.put("action", new I18nizableText("org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.act"));
+        }
+        
+        // Label
+        if (this._initialParameters.get("label") == null)
+        {
+            this._initialParameters.put("label", new I18nizableText("application", _workflowStepName));
+        }
+        
+        // Description
+        if (this._initialParameters.get("default-description") == null)
+        {
+            this._initialParameters.put("default-description", new I18nizableText("application", _workflowStepName + "_DESCRIPTION"));
+        }
+        
+        // Footer
+        if (this._initialParameters.get("footer") == null)
+        {
+            this._initialParameters.put("footer", new I18nizableText("application", _workflowStepName + "_FOOTER"));
+        }
+        
+        // Icons
+        String[] icons = new String[]{"-small", "-medium", "-large"};
+        for (String icon : icons)
+        {
+            if (this._initialParameters.get("icon" + icon) == null)
+            {
+                I18nizableText workflowStepName = new I18nizableText("application", _workflowStepName);
+                if ("application".equals(workflowStepName.getCatalogue()))
+                {
+                    this._initialParameters.put("icon" + icon, new I18nizableText("/plugins/forms/resources_workflow/" + workflowStepName.getKey() + icon + ".png"));
+                }
+                else
+                {
+                    String pluginName = workflowStepName.getCatalogue().substring("plugin.".length());
+                    this._initialParameters.put("icon" + icon, new I18nizableText("/plugins/" + pluginName + "/resources/img/workflow/" + workflowStepName.getKey() + icon + ".png"));
+                }
+            }
+        }
+    }
+    
+    private void _advancedScriptParameters()
+    {
+        // Workflow name
+        if (this._initialParameters.get("workflow-step") == null)
+        {
+            this._initialParameters.put("workflow-step", new I18nizableText(Integer.toString(_workflowStepId)));
+        }
+
+        // Step id
+        if (this._initialParameters.get("workflow-name") == null)
+        {
+            this._initialParameters.put("workflow-name", new I18nizableText(_workflowName));
+        }
+
+        // Multi selection
+        if (this._initialParameters.get("enable-multiselection") == null)
+        {
+            this._initialParameters.put("enable-multiselection", new I18nizableText("true"));
+        }
+
+        // descriptions
+        if (this._initialParameters.get("entryselected-description") == null)
+        {
+            this._initialParameters.put("entryselected-description", new I18nizableText("plugin.forms", "ENTRY_WORKFLOW_DESCRIPTION"));
+        }
+        if (this._initialParameters.get("noselection-description") == null)
+        {
+            this._initialParameters.put("noselection-description", new I18nizableText("plugin.forms", "ENTRY_WORKFLOW_NOSELECTION_DESCRIPTION"));
+        }
+        if (this._initialParameters.get("refreshing-description") == null)
+        {
+            this._initialParameters.put("refreshing-description", new I18nizableText("plugin.forms", "ENTRY_WORKFLOW_REFRESH_DESCRIPTION"));
+        }
+        if (this._initialParameters.get("nomatch-description") == null)
+        {
+            this._initialParameters.put("nomatch-description", new I18nizableText("plugin.forms", "ENTRY_WORKFLOW_NOMATCH_DESCRIPTION"));
+        }
+        if (this._initialParameters.get("noaction-available-description") == null)
+        {
+            this._initialParameters.put("noaction-available-description", new I18nizableText("plugin.forms", "ENTRY_WORKFLOW_NOACTIONAVAILABLE_DESCRIPTION"));
+        }
+        if (this._initialParameters.get("multiselection-disabled-description") == null)
+        {
+            this._initialParameters.put("multiselection-disabled-description", new I18nizableText("plugin.forms", "ENTRY_WORKFLOW_NOMULTISELECT_DESCRIPTION"));
+        }
+    }
+    
+    private void _workflowActionScriptParameters()
+    {
+        this._initialParameters.put("menu-size", new I18nizableText(Integer.toString(_workflowActionsIds.length)));
+        
+        for (int i = 0; i < _workflowActionsIds.length; i++)
+        {
+            int actionId = _workflowActionsIds[i];
+            String actionName = _formEntriesWorkflow.getActionName(_workflowName, actionId);
+            
+            this._initialParameters.put("menu-" + i, new I18nizableText(Integer.toString(actionId)));
+            
+            if (this._initialParameters.get("menu-" + actionId + "-label") == null)
+            {
+                this._initialParameters.put("menu-" + actionId + "-label", new I18nizableText("application", actionName));
+            }
+            if (this._initialParameters.get("menu-" + actionId + "-description") == null)
+            {
+                this._initialParameters.put("menu-" + actionId + "-description", new I18nizableText("application", actionName + "_DESCRIPTION"));
+            }
+            if (this._initialParameters.get("menu-" + actionId + "-action") == null)
+            {
+                this._initialParameters.put("menu-" + actionId + "-action", new I18nizableText("org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.menuAct"));
+            }
+            if (this._initialParameters.get("menu-" + actionId + "-comment") == null)
+            {
+                this._initialParameters.put("menu-" + actionId + "-comment", new I18nizableText(String.valueOf(_commentActionsIds.contains(actionId))));
+            }
+            if (this._initialParameters.get("menu-" + actionId + "-further-information") == null)
+            {
+                this._initialParameters.put("menu-" + actionId + "-further-information", new I18nizableText(String.valueOf(_furtherInformationActionsIds.contains(actionId))));
+            }
+            if (this._initialParameters.get("menu-" + actionId + "-enable-multiselection") == null)
+            {
+                this._initialParameters.put("menu-" + actionId + "-enable-multiselection", new I18nizableText("true"));
+            }
+        }
+    }
+    
+    @Override
+    protected String _configureClass(Configuration configuration) throws ConfigurationException
+    {
+        String jsClassName = configuration.getAttribute("class", "org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu");
+        if (getLogger().isDebugEnabled())
+        {
+            getLogger().debug("Js class configured is '" + jsClassName + "'");
+        }
+        return jsClassName;        
+    }
+    
+    @Override
+    protected Script _configureScript(Configuration configuration) throws ConfigurationException
+    {
+        Script script = super._configureScript(configuration);
+        script.getScriptFiles().add("/plugins/forms/resources/js/org/ametys/forms/workflow/FormEntriesWorkflowMenu.i18n.js");
+        return script;
+    }
+    
+    @Override
+    @SuppressWarnings("unchecked")
+    public Map<String, I18nizableText> getCurrentParameters(Map<String, Object> parameters)
+    {
+        Map<String, I18nizableText> results = new HashMap<String, I18nizableText>();
+        
+        int count = 0;
+        
+        String formId = (String) parameters.get("formId");
+        List<Integer> formEntryIds = (List<Integer>) parameters.get("entryIds");
+        
+        List<UserEntry> allEntries = new ArrayList<UserEntry> ();
+        try
+        {
+            Form form = _formPropertiesManager.getForm(formId);
+            Map<String, FieldValue> columns = _formTableManager.getColumns(form);
+           
+            allEntries = _formTableManager.getSubmissions(form, columns, 0, Integer.MAX_VALUE, formEntryIds);
+
+            for (UserEntry entry : allEntries)
+            {
+                Integer workflowId = entry.getWorkflowId();
+                
+                List<Step> steps = _formEntriesWorkflow.getCurrentSteps(workflowId);
+                List<Integer> stepIds = new ArrayList<Integer>();
+                for (Step step : steps)
+                {
+                    stepIds.add(step.getStepId());
+                }
+                
+                if (stepIds.contains(_workflowStepId))
+                {
+                    Map<String, Object> transientVars = new HashMap<String, Object>();
+                    
+                    // Used to check the rights on the form's content
+                    Content formContent = _formPropertiesManager.getFormContent(form.getId());
+                    transientVars.put(AbstractContentWorkflowComponent.CONTENT_KEY, formContent);
+                    
+                    int[] availableActions = _formEntriesWorkflow.getAvailableActions(workflowId, transientVars);
+                    Arrays.sort(availableActions);
+                    
+                    results.put("entry-" + count + "-id", new I18nizableText(Integer.toString(entry.getId())));
+                    results.put("entry-" + count + "-workflowId", new I18nizableText(Integer.toString(workflowId)));
+                    
+                    for (int i = 0; i < this._workflowActionsIds.length; i++)
+                    {
+                        int actionId = this._workflowActionsIds[i];
+                        
+                        boolean activeAction = Arrays.binarySearch(availableActions, actionId) >= 0;
+                        
+                        results.put("entry-" + count + "-action-" + actionId, new I18nizableText(Boolean.toString(activeAction)));
+                    }
+                    
+                    count++;
+                }
+            }
+        }
+        catch (FormsException e)
+        {
+            getLogger().error("Error getting forms for a content.", e);
+        }
+
+        results.put("entry-count", new I18nizableText(Integer.toString(count)));
+        return results;
+    }
+}
Index: main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormEntriesWorkflowsGenerator.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormEntriesWorkflowsGenerator.java	(revision 0)
+++ main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormEntriesWorkflowsGenerator.java	(revision 0)
@@ -0,0 +1,130 @@
+/*
+ *  Copyright 2016 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.plugins.forms.workflow;
+
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.List;
+
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.ProcessingException;
+import org.apache.cocoon.generation.ServiceableGenerator;
+import org.apache.cocoon.xml.AttributesImpl;
+import org.apache.cocoon.xml.XMLUtils;
+import org.xml.sax.SAXException;
+
+import org.ametys.cms.workspace.ribbon.RibbonTabsManager;
+
+import com.opensymphony.workflow.loader.StepDescriptor;
+import com.opensymphony.workflow.loader.WorkflowDescriptor;
+
+/**
+ * This class generate the ids of the extensions used for each workflow tab
+ */
+public class FormEntriesWorkflowsGenerator extends ServiceableGenerator
+{
+    /** The Workflow component for form entries */
+    private FormEntriesWorkflow _formEntriesWorkflow;
+    
+    /** The ribbon tabs manager */
+    private RibbonTabsManager _ribbonTabsManager;
+    
+    /** The beginning of the id every workflow tab extension */
+    private static final String __FORM_WORKFLOW_TAB_EXTENSION_ID_BEGIN = "org.ametys.plugins.forms.workflow.FormEntriesWorkflowTab";
+    
+    /** The beginning of the id every workflow state button */
+    private static final String __FORM_WORKFLOW_STATE_EXTENSION_ID_BEGIN = "org.ametys.plugins.forms.workflow.FormEntriesWorkflowButton";
+    
+    @Override
+    public void service(ServiceManager serviceManager) throws ServiceException
+    {
+        _formEntriesWorkflow = (FormEntriesWorkflow) serviceManager.lookup(FormEntriesWorkflow.ROLE);
+        _ribbonTabsManager = (RibbonTabsManager) serviceManager.lookup(RibbonTabsManager.ROLE);
+    }
+    
+    @Override
+    public void generate() throws IOException, SAXException, ProcessingException
+    {
+        String[] formWorkflowNames = _formEntriesWorkflow.getWorkflowNames();
+        
+        AttributesImpl attrs = new AttributesImpl();
+        
+        contentHandler.startDocument();
+        
+        for (String workflowName : formWorkflowNames)
+        {
+            if (workflowName.startsWith("form-"))
+            {
+                String workflowTabExtensionId = __FORM_WORKFLOW_TAB_EXTENSION_ID_BEGIN + "." + workflowName;
+                
+                if (_ribbonTabsManager.getExtension(workflowTabExtensionId) == null)
+                {
+                    getLogger().warn("There is no tab defined for the id '" + workflowTabExtensionId + "'. "
+                            + "Manipulating the workflow '" + workflowName + "' on form entries is therefore inacessible.");
+                }
+                else
+                {
+                    AttributesImpl workflowTabAtts = new AttributesImpl();
+                    workflowTabAtts.addCDATAAttribute("tabId", workflowTabExtensionId);
+    
+                    AttributesImpl groupAtts = new AttributesImpl();
+                    groupAtts.addCDATAAttribute("label", "plugin.forms:RIBBON_TABS_TAB_FORM_ENTRY_WORKFLOW_LABEL");
+                    
+                    
+                    List<String> workflowStepNames = _getWorkflowStepsNames(workflowName);
+                    XMLUtils.startElement(contentHandler, "workflow-tab", workflowTabAtts);
+                    XMLUtils.startElement(contentHandler, "group", groupAtts);
+                    XMLUtils.createElement(contentHandler, "large");
+                    XMLUtils.startElement(contentHandler, "medium");
+                    for (String stepName : workflowStepNames)
+                    {
+                        attrs.addCDATAAttribute("id", __FORM_WORKFLOW_STATE_EXTENSION_ID_BEGIN + '.' + workflowName + '.' + stepName);
+                        XMLUtils.createElement(contentHandler, "control", attrs);
+                        attrs.clear();
+                    }
+                    XMLUtils.endElement(contentHandler, "medium");
+                    XMLUtils.createElement(contentHandler, "small");
+                    
+                    XMLUtils.endElement(contentHandler, "group");
+                    XMLUtils.endElement(contentHandler, "tab-extensions");
+                    
+                    workflowTabAtts.clear();
+                }
+            }
+        }
+        
+        contentHandler.endDocument();
+    }
+    
+    @SuppressWarnings("cast")
+    private List<String> _getWorkflowStepsNames(String workflowName)
+    {
+        List<String> workflowStepNames = new ArrayList<String> ();
+        WorkflowDescriptor workflowDescriptor = _formEntriesWorkflow.getWorkflowDescriptor(workflowName);
+        List<StepDescriptor> stepDescriptors = (List<StepDescriptor>) workflowDescriptor.getSteps();
+        
+        for (StepDescriptor stepDescriptor : stepDescriptors)
+        {
+            String stepKey = stepDescriptor.getName();
+            String stepName = stepKey.substring(stepKey.lastIndexOf("_") + 1, stepKey.length());
+
+            workflowStepNames.add(stepName.toLowerCase());
+        }
+        
+        return workflowStepNames;
+    }
+}
Index: main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormParser.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormParser.java	(revision 40266)
+++ main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormParser.java	(working copy)
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2010 Anyware Services
+ *  Copyright 2016 Anyware Services
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -130,6 +130,7 @@
             String receiptFieldBody = StringUtils.defaultString(_getAttribute(formNode, "receipt_body"));
             String redirectTo = StringUtils.defaultString(_getAttribute(formNode, "redirect"));
             String emails = StringUtils.defaultString(_getAttribute(formNode, "processing_emails"));
+            String workflowName = StringUtils.defaultString(_getAttribute(formNode, "workflow")); 
             
             emails = URLDecoder.decode(emails, "UTF-8");
             
@@ -152,6 +153,7 @@
             form.setReceiptFieldBody(receiptFieldBody);
             form.setNotificationEmails(emailSet);
             form.setRedirectTo(redirectTo);
+            form.setWorkflowName(workflowName);
             
         }
         catch (UnsupportedEncodingException e)
@@ -170,7 +172,7 @@
      * @param attributeName the name of the attribute
      * @return the value of an attribute of an input
      */
-    protected String _getAttribute(Node node, String attributeName)
+    public String _getAttribute(Node node, String attributeName)
     {
         NamedNodeMap attributes = node.getAttributes();
         Node idAttribute = attributes.getNamedItem(attributeName);
Index: main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormWorkflowClientSideElement.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormWorkflowClientSideElement.java	(revision 0)
+++ main/plugin-forms/src/org/ametys/plugins/forms/workflow/FormWorkflowClientSideElement.java	(revision 0)
@@ -0,0 +1,65 @@
+/*
+ *  Copyright 2016 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.plugins.forms.workflow;
+
+import java.util.HashMap;
+import java.util.Map;
+
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+
+import org.ametys.runtime.ui.impl.StaticContextualClientSideElement;
+import org.ametys.runtime.util.I18nizableText;
+
+/**
+ * This static client side allows to gather the form-dedicated workflows listed in the 'workflows.xml' file
+ */
+public class FormWorkflowClientSideElement extends StaticContextualClientSideElement
+{
+    /** The Workflow component for form entries */
+    private FormEntriesWorkflow _formEntriesWorkflow;
+    
+    @Override
+    public void service(ServiceManager serviceManager) throws ServiceException
+    {   
+        _formEntriesWorkflow = (FormEntriesWorkflow) serviceManager.lookup(FormEntriesWorkflow.ROLE);
+    }   
+    
+    @Override
+    public Map<String, I18nizableText> getParameters(Map<String, Object> contextualParameters)
+    {
+        Map<String, I18nizableText> initialParameters = new HashMap<String, I18nizableText>(super.getParameters(contextualParameters));
+        String[] workflowNames = _formEntriesWorkflow.getWorkflowNames();
+        
+        int i = 0;
+        initialParameters.put(i + "-label", new I18nizableText("plugin.forms", "PLUGINS_FORMS_FORMS_EDITOR_WORKFLOW_NO_WORKFLOW"));
+        i++;
+        
+        for (String workflowName : workflowNames)
+        {
+            if (workflowName.startsWith("form-"))
+            {
+                initialParameters.put(i + "-value", new I18nizableText(workflowName));
+                initialParameters.put(i + "-label", new I18nizableText("application", "WORKFLOW_" + workflowName));
+
+                i++;
+            }
+        }
+        initialParameters.put("count", new I18nizableText(Integer.toString(i)));
+        
+        return initialParameters;
+    }
+}
